package sun.java2d.pipe;

import java.awt.font.FontRenderContext;
import java.awt.font.GlyphVector;
import java.awt.Shape;
import java.awt.geom.AffineTransform;
import java.awt.font.TextLayout;
import sun.java2d.SunGraphics2D;

public class OutlineTextRenderer implements TextPipe
{
    public static final int THRESHHOLD = 100;
    
    public OutlineTextRenderer() {
    }
    
    @Override
    public void drawChars(SunGraphics2D sunGraphics2D, char[] value, int offset, int count, int n, int n2) {
        this.drawString(sunGraphics2D, new String(value, offset, count), (double)n, (double)n2);
    }
    
    @Override
    public void drawString(SunGraphics2D sunGraphics2D, String s, double tx, double ty) {
        if ("".equals(s)) {
            return;
        }
        Shape outline = new TextLayout(s, sunGraphics2D.getFont(), sunGraphics2D.getFontRenderContext()).getOutline(AffineTransform.getTranslateInstance(tx, ty));
        int aaHint = sunGraphics2D.getFontInfo().aaHint;
        int antialiasHint = -1;
        if (aaHint != 1 && sunGraphics2D.antialiasHint != 2) {
            antialiasHint = sunGraphics2D.antialiasHint;
            sunGraphics2D.antialiasHint = 2;
            sunGraphics2D.validatePipe();
        }
        else if (aaHint == 1 && sunGraphics2D.antialiasHint != 1) {
            antialiasHint = sunGraphics2D.antialiasHint;
            sunGraphics2D.antialiasHint = 1;
            sunGraphics2D.validatePipe();
        }
        sunGraphics2D.fill(outline);
        if (antialiasHint != -1) {
            sunGraphics2D.antialiasHint = antialiasHint;
            sunGraphics2D.validatePipe();
        }
        return;
    }
    
    @Override
    public void drawGlyphVector(SunGraphics2D sunGraphics2D, GlyphVector glyphVector, float n, float n2) {
        Shape outline = glyphVector.getOutline(n, n2);
        int antialiasHint = -1;
        FontRenderContext fontRenderContext = glyphVector.getFontRenderContext();
        int antiAliased = fontRenderContext.isAntiAliased();
        if (antiAliased != 0 && sunGraphics2D.getGVFontInfo(glyphVector.getFont(), fontRenderContext).aaHint == 1) {
            antiAliased = 0;
        }
        if (antiAliased != 0 && sunGraphics2D.antialiasHint != 2) {
            antialiasHint = sunGraphics2D.antialiasHint;
            sunGraphics2D.antialiasHint = 2;
            sunGraphics2D.validatePipe();
        }
        else if (antiAliased == 0 && sunGraphics2D.antialiasHint != 1) {
            antialiasHint = sunGraphics2D.antialiasHint;
            sunGraphics2D.antialiasHint = 1;
            sunGraphics2D.validatePipe();
        }
        sunGraphics2D.fill(outline);
        if (antialiasHint != -1) {
            sunGraphics2D.antialiasHint = antialiasHint;
            sunGraphics2D.validatePipe();
        }
    }
}
